"use strict";

exports.__esModule = true;
exports.processDocument = exports.SUPPORTED_PARSERS = void 0;

const archieml = require('archieml');

const marked = require('marked');

const SUPPORTED_PARSERS = ['markdown', 'archieml'];
exports.SUPPORTED_PARSERS = SUPPORTED_PARSERS;

const parseArchie = content => archieml.load(content);

const parseMarkdown = content => marked.lexer(content);

const processDocument = (options, contentRaw) => {
  let formattedContent = {
    raw: contentRaw
  };
  if (options.format === 'archieml') formattedContent = { ...formattedContent,
    archieml: parseArchie(contentRaw)
  };else if (options.format === 'markdown') formattedContent = { ...formattedContent,
    markdown: parseMarkdown(contentRaw)
  };
  return formattedContent;
};

exports.processDocument = processDocument;